Package com.io7m.waxmill.xml.vm.v1

# Class WXM1LinuxKernelDevice

java.lang.Object
com.io7m.waxmill.xml.vm.v1.WXM1LinuxKernelDevice

All Implemented Interfaces:
  `WXM1LinuxKernelDeviceType`

    public final class WXM1LinuxKernelDevice
    extends java.lang.Object
    implements WXM1LinuxKernelDeviceType

Immutable implementation of `WXM1LinuxKernelDeviceType`.

Use the builder to create immutable instances: `WXM1LinuxKernelDevice.builder()`.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXM1LinuxKernelDevice.Builder` | Builds instances of type `WXM1LinuxKernelDevice`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXM1LinuxKernelDevice.Builder` | `builder()` | Creates a builder for `WXM1LinuxKernelDevice`.
  `static WXM1LinuxKernelDevice` | `copyOf​(WXM1LinuxKernelDeviceType instance)` | Creates an immutable copy of a `WXM1LinuxKernelDeviceType` value.
  `WXMDeviceSlot` | `deviceSlot()` |
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXM1LinuxKernelDevice` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `deviceSlot`, `kernelPath`.
  `java.nio.file.Path` | `kernelPath()` |
  `java.lang.String` | `toString()` | Prints the immutable value `WXM1LinuxKernelDevice` with attribute values.
  `WXM1LinuxKernelDevice` | `withDeviceSlot​(WXMDeviceSlot value)` | Copy the current immutable object by setting a value for the `deviceSlot` attribute.
  `WXM1LinuxKernelDevice` | `withKernelPath​(java.nio.file.Path value)` | Copy the current immutable object by setting a value for the `kernelPath` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### deviceSlot

    public WXMDeviceSlot deviceSlot()
    Specified by:
      `deviceSlot` in interface `WXM1LinuxKernelDeviceType`
    Returns:
      The value of the `deviceSlot` attribute

  - ### kernelPath

    public java.nio.file.Path kernelPath()
    Specified by:
      `kernelPath` in interface `WXM1LinuxKernelDeviceType`
    Returns:
      The value of the `kernelPath` attribute

  - ### withDeviceSlot

    public final WXM1LinuxKernelDevice withDeviceSlot​(WXMDeviceSlot value)
    Copy the current immutable object by setting a value for the `deviceSlot` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for deviceSlot
    Returns:
      A modified copy of the `this` object

  - ### withKernelPath

    public final WXM1LinuxKernelDevice withKernelPath​(java.nio.file.Path value)
    Copy the current immutable object by setting a value for the `kernelPath` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for kernelPath
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXM1LinuxKernelDevice` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `deviceSlot`, `kernelPath`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXM1LinuxKernelDevice` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXM1LinuxKernelDevice copyOf​(WXM1LinuxKernelDeviceType instance)
    Creates an immutable copy of a `WXM1LinuxKernelDeviceType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXM1LinuxKernelDevice instance

  - ### builder

    public static WXM1LinuxKernelDevice.Builder builder()
    Creates a builder for `WXM1LinuxKernelDevice`.

         WXM1LinuxKernelDevice.builder()
            .setDeviceSlot(com.io7m.waxmill.machines.WXMDeviceSlot) // required deviceSlot
            .setKernelPath(java.nio.file.Path) // required kernelPath
            .build();

    Returns:
      A new WXM1LinuxKernelDevice builder